=== debian/changelog ===
freefem++ (4.14+dfsg-1build5) plucky; urgency=medium

  * No-change rebuild against libhdf5-310

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 27 Jan 2025 17:59:59 +0000

freefem++ (4.14+dfsg-1build4) plucky; urgency=medium

  * No-change rebuild for openmpi

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 06 Dec 2024 10:38:37 +0000

freefem++ (4.14+dfsg-1build3) plucky; urgency=medium

  * No-change rebuild for libsuperlu7

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 26 Nov 2024 09:48:18 +0000

freefem++ (4.14+dfsg-1build2) oracular; urgency=medium

  * No-change rebuild against mpi-defaults 1.17

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 30 Aug 2024 18:58:44 +0000

freefem++ (4.14+dfsg-1build1) oracular; urgency=medium

  * Rebuild against new libgsl28.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 30 Jul 2024 08:37:32 +0200

freefem++ (4.14+dfsg-1) unstable; urgency=medium

  * New upstream version.

 -- Francois Mazen <mzf@debian.org>  Sat, 13 Apr 2024 17:40:52 +0200
